-- Vinny Loader by David Down
-- coding: utf-8
import "Turbine.Gameplay"

function print(text) Turbine.Shell.WriteLine("<rgb=#00FFFF>VL:</rgb> "..text) end
function printe(text) print("<rgb=#FF6040>Error: "..text.."</rgb>") end
import "Vinny.Common.Help"
local VLv = Plugins["VinnyLoader"]:GetVersion()

VL_Opt = Turbine.PluginData.Load(Turbine.DataScope.Server,"VinnyLoader_Opt")
if not VL_Opt then VL_Opt = {auto=true} end
import "Vinny.VinnyLoader.VL_Window"
VL_window = VL_Window()
if VL_Opt then
	if not VL_Opt.auto then VL_window:SetVisible( false ) end
	if VL_Opt.pos1 then
		local x,y = VL_window:GetPosition()
		if y>VL_Opt.pos1.y then
			VL_window:SetPosition(VL_Opt.pos1.x,VL_Opt.pos1.y)
		end
	end
	if VL_Opt.add then
		for i,name in pairs(VL_Opt.add) do
			local t = pFind(AP,name)
			if t then VL_window:Add(t) end
		end
	end
end
print("Vinny Loader "..VLv.." initialized.")

function VL_Add(name,msg)
	local t = pFind(AP,name)
	if not t then printe(name.." not found.") return end
	if VL_Opt.add then 
		for i,vp in ipairs(VL_Opt.add) do
			if vp.f==name then printe(name.." already added.") return end
		end
	else VL_Opt.add = {} end
	VL_window:Add(t,msg)
	table.insert(VL_Opt.add,name)
	Turbine.PluginData.Save(Turbine.DataScope.Server,"VinnyLoader_Opt",VL_Opt)
end

function VL_Rem(name)
	if not VL_Opt.add then printe("Not found.") return end
	local ix
	for i,pn in ipairs(VL_Opt.add) do
		if pn==name then ix = i break end
	end
	if not ix then printe(name.." not found.") return end
--	VL_window:Rem(t)
	print(name.." removed.")
	table.remove(VL_Opt.add,ix)
	Turbine.PluginData.Save(Turbine.DataScope.Server,"VinnyLoader_Opt",VL_Opt)
end

VL_Command = Turbine.ShellCommand()

function VL_Command:GetShortHelp() return Vinny.Common.Help(help,"??") end
function VL_Command:GetHelp() return Vinny.Common.Help(help,"help") end

function VL_Command:Execute( cmd,args )
	if Vinny.Common.HelpCmd(cmd,args,help) then return end
    if cmd=="vl" then
		local vis = not VL_window:IsVisible()
		VL_window:SetVisible(vis)
		print("Window "..(vis and "displayed" or "hidden"))
		return
	end
    if cmd=="vla" then VL_Add(args,true)
	elseif cmd=="vlr" then VL_Rem(args) end
end

Turbine.Shell.AddCommand( "vl;vla;vlr;vl?", VL_Command )

-- Options panel
import "Vinny.Common.Options"
OP = Vinny.Common.Options_Init(print,VL_Opt,VL_window,"VinnyLoader_Opt")

local Small = Vinny.Common.Options_Box(OP,30," Use small icons")
if VL_Opt.small then Small:SetChecked(true) end
Small.CheckedChanged = function( sender, args )
	VL_Opt.small = sender:IsChecked()
	print((VL_Opt.small and "En" or "Dis").."abled small icons.")
	Turbine.PluginData.Save(Turbine.DataScope.Server,"VinnyLoader_Opt",VL_Opt)
end

-- Help text
help = {
	pre = "vl",
	arg = {
		[" "] = "Show/Hide the VL window,",
	},
	cmd = {
		["vla <name>"] = "Add the plugin <name>.",
		["vlr <name>"] = "Remove the plugin <name>.",
	},
}